Index: /trunk/LMDZ.GENERIC/libf/phystd/convadj.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/convadj.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/convadj.F	(revision 253)
@@ -1,23 +1,29 @@
-      SUBROUTINE convadj(ngrid,nlay,nq,ptimestep,
-     S                   pplay,pplev,ppopsk,
-     $                   pu,pv,ph,pq,
-     $                   pdufi,pdvfi,pdhfi,pdqfi,
-     $                   pduadj,pdvadj,pdhadj,
-     $                   pdqadj)
-      IMPLICIT NONE
-
-c=======================================================================
-c
-c   ajustement convectif sec
-c   on ajoute les tendances pdhfi au profil pdh avant l'ajustement
-c   SPECIAL VERSION : if one tracer is CO2, take into account the
-c   Molecular mass variation (e.g. when CO2 condense) to trigger
-c   convection  F. Forget 01/2005
-c
-c=======================================================================
-
-c-----------------------------------------------------------------------
-c   declarations:
-c   -------------
+      subroutine convadj(ngrid,nlay,nq,ptimestep,
+     &                   pplay,pplev,ppopsk,
+     &                   pu,pv,ph,pq,
+     &                   pdufi,pdvfi,pdhfi,pdqfi,
+     &                   pduadj,pdvadj,pdhadj,
+     &                   pdqadj)
+
+      implicit none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Calculates dry convective adjustment. If one tracer is CO2,
+!     we take into account the molecular mass variation (e.g. when
+!     CO2 condenses) to trigger convection (F. Forget 01/2005)
+!
+!     Authors
+!     -------
+!     Original author unknown.
+!     Modif. 2005 by F. Forget.
+!     
+!==================================================================
+
+!     ------------
+!     Declarations
+!     ------------
 
 #include "dimensions.h"
@@ -28,6 +34,6 @@
 
 
-c   arguments:
-c   ----------
+!     Arguments
+!     ---------
 
       INTEGER ngrid,nlay
@@ -38,5 +44,5 @@
       REAL pv(ngrid,nlay),pdvfi(ngrid,nlay),pdvadj(ngrid,nlay)
 
-c    Traceurs :
+!     Tracers
       integer nq
       real pq(ngrid,nlay,nq), pdqfi(ngrid,nlay,nq)
@@ -44,6 +50,6 @@
 
 
-c   local:
-c   ------
+!     Local
+!     -----
 
       INTEGER ig,i,l,l1,l2,jj
@@ -56,7 +62,6 @@
       REAL zh2(ngridmx,nlayermx), zhc(ngridmx,nlayermx)
       REAL zhm,zsm,zdsm,zum,zvm,zalpha,zhmc
-      
-
-c    Traceurs :
+
+!     Tracers
       INTEGER iq,ico2
       save ico2
@@ -65,6 +70,4 @@
       real m_co2, m_noco2, A , B
       save A, B
-c    Temporaire (for diagnostic)
-c      REAL diag_alpha(ngridmx)
 
       real mtot1, mtot2 , mm1, mm2
@@ -74,14 +77,17 @@
       data firstcall/.true./
 
+!     for conservation test
+      real masse,cadjncons
+
       EXTERNAL SCOPY
-c
-c-----------------------------------------------------------------------
-c   initialisation:
-c   ---------------
-c
+
+!     --------------
+!     Initialisation
+!     --------------
+
       IF (firstcall) THEN 
         IF(ngrid.NE.ngridmx) THEN
            PRINT*
-           PRINT*,'STOP dans convadj'
+           PRINT*,'STOP in convadj'
            PRINT*,'ngrid    =',ngrid
            PRINT*,'ngridmx  =',ngridmx
@@ -89,5 +95,5 @@
         ico2=0
         if (tracer) then
-c          Prepare Special treatment if one of the tracer is CO2 gas
+!     Prepare Special treatment if one of the tracers is CO2 gas
            do iq=1,nqmx
              if (noms(iq).eq."co2") then
@@ -97,8 +103,8 @@
                 m_co2 = 44.01E-3  ! CO2 molecular mass (kg/mol)   
                 m_noco2 = 33.37E-3  ! Non condensible mol mass (kg/mol)   
-c               Compute A and B coefficient use to compute
-c               mean molecular mass Mair defined by
-c               1/Mair = q(ico2)/m_co2 + (1-q(ico2))/m_noco2
-c               1/Mair = A*q(ico2) + B
+!               Compute A and B coefficient use to compute
+!               mean molecular mass Mair defined by
+!               1/Mair = q(ico2)/m_co2 + (1-q(ico2))/m_noco2
+!               1/Mair = A*q(ico2) + B
                 A =(1/m_co2 - 1/m_noco2)
                 B=1/m_noco2
@@ -108,17 +114,4 @@
         firstcall=.false.
       ENDIF ! of IF (firstcall)
-
-c
-c-----------------------------------------------------------------------
-c   detection des profils a modifier:
-c   ---------------------------------
-c   si le profil est a modifier
-c   (i.e. ph(niv_sup) < ph(niv_inf) )
-c   alors le tableau "vtest" est mis a .TRUE. ;
-c   sinon, il reste a sa valeur initiale (.FALSE.)
-c   cette operation est vectorisable
-c   On en profite pour copier la valeur initiale de "ph"
-c   dans le champ de travail "zh"
-
 
       DO l=1,nlay
@@ -140,5 +133,4 @@
       end if
 
-
       CALL scopy(ngrid*nlay,zh,1,zh2,1)
       CALL scopy(ngrid*nlay,zu,1,zu2,1)
@@ -146,10 +138,15 @@
       CALL scopy(ngrid*nlay*nq,zq,1,zq2,1)
 
+!     -----------------------------
+!     Detection of unstable columns
+!     -----------------------------
+!     If ph(above) < ph(below) we set vtest=.true.
+
       DO ig=1,ngrid
-        vtest(ig)=.FALSE.
-      ENDDO
-c
+        vtest(ig)=.false.
+      ENDDO
+
       if (ico2.ne.0) then
-c        Special case if one of the tracer is CO2 gas
+!     Special case if one of the tracers is CO2 gas
          DO l=1,nlay
            DO ig=1,ngrid
@@ -161,12 +158,12 @@
        end if
 
-       
-
+!     Find out which grid points are convectively unstable
       DO l=2,nlay
         DO ig=1,ngrid
-          IF(zhc(ig,l).LT.zhc(ig,l-1)) vtest(ig)=.TRUE.
+          IF(zhc(ig,l).LT.zhc(ig,l-1)) vtest(ig)=.true.
         ENDDO
       ENDDO
-c
+
+!     Make a list of them
       jcnt=0
       DO ig=1,ngrid
@@ -178,13 +175,13 @@
 
 
-c-----------------------------------------------------------------------
-c  Ajustement des "jcnt" profils instables indices par "jadrs":
-c  ------------------------------------------------------------
-c
+!     ---------------------------------------------------------------
+!     Adjustment of the "jcnt" unstable profiles indicated by "jadrs"
+!     ---------------------------------------------------------------
+
       DO jj = 1, jcnt   ! loop on every convective grid point
-c
+
           i = jadrs(jj)
  
-c   Calcul des niveaux sigma sur cette colonne
+!     Calculate sigma in this column
           DO l=1,nlay+1
             sig(l)=pplev(i,l)/pplev(i,1)
@@ -196,15 +193,13 @@
          ENDDO
           l2 = 1
-c
-c      -- boucle de sondage vers le haut
-c
-cins$     Loop  vers le haut sur l2
+
+!     Test loop upwards on l2
+
           DO
-c
             l2 = l2 + 1
             IF (l2 .GT. nlay) EXIT
             IF (zhc(i, l2) .LT. zhc(i, l2-1)) THEN
  
-c          -- l2 est le niveau le plus haut de la colonne instable
+!     l2 is the highest level of the unstable column
  
               l1 = l2 - 1
@@ -214,9 +209,8 @@
               zhm = zh2(i, l2)
               if(ico2.ne.0) zqco2m = zq2(i,l2,ico2)
-c
-c          -- boucle de sondage vers le bas
-c             Loop
+
+!     Test loop downwards
+
               DO
-c
                 zsm = zsm + sdsig(l)
                 zdsm = zdsm + dsig(l)
@@ -230,36 +224,38 @@
                 end if
  
-c            -- doit on etendre la colonne vers le bas ?
- 
-                down = .FALSE.
-                IF (l1 .NE. 1) THEN    !--  and then
-                  IF (zhmc .LT. zhc(i, l1-1)) THEN
-                    down = .TRUE.
+!     do we have to extend the column downwards?
+ 
+                down = .false.
+                IF (l1 .ne. 1) then    !--  and then
+                  IF (zhmc .lt. zhc(i, l1-1)) then
+                    down = .true.
                   END IF
                 END IF
  
-                IF (down) THEN
+                ! this could be a problem...
+
+                if (down) then
  
                   l1 = l1 - 1
                   l  = l1
  
-                ELSE
- 
-c              -- peut on etendre la colonne vers le haut ?
- 
-                  IF (l2 .EQ. nlay) EXIT
- 
-                  IF (zhc(i, l2+1) .GE. zhmc) EXIT
-c
+                else
+ 
+!     can we extend the column upwards?
+ 
+                  if (l2 .eq. nlay) exit
+ 
+                  if (zhc(i, l2+1) .ge. zhmc) exit
+
                   l2 = l2 + 1
                   l  = l2
-c
-                END IF
-c
-cins$         End Loop
-              ENDDO
-c
-c          -- nouveau profil : constant (valeur moyenne)
-c
+
+                end if
+
+              enddo
+
+!     New constant profile (average value)
+
+
               zalpha=0.
               zum=0.
@@ -276,8 +272,19 @@
                 endif
                 zh2(i, l) = zhm
-                zum=zum+dsig(l)*zu(i,l)
-                zvm=zvm+dsig(l)*zv(i,l)
+!     modifs by RDW !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+                zum=zum+dsig(l)*zu2(i,l)
+                zvm=zvm+dsig(l)*zv2(i,l)
+!                zum=zum+dsig(l)*zu(i,l)
+!                zvm=zvm+dsig(l)*zv(i,l)
                 do iq=1,nq
-                   zqm(iq) = zqm(iq)+dsig(l)*zq(i,l,iq)
+                   zqm(iq) = zqm(iq)+dsig(l)*zq2(i,l,iq)
+!                   zqm(iq) = zqm(iq)+dsig(l)*zq(i,l,iq)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+!     to conserve tracers/ KE, we must calculate zum, zvm and zqm using 
+!     the up-to-date column values. If we do not do this, there are cases 
+!     where convection stops at one level and starts at the next where we
+!     can break conservation of stuff (particularly tracers) significantly.
+
                 end do
               ENDDO
@@ -292,5 +299,5 @@
                  zalpha=1.
               ELSE
-c                IF(zalpha.LT.0.) STOP
+!                IF(zalpha.LT.0.) STOP
                  IF(zalpha.LT.1.e-4) zalpha=1.e-4
               ENDIF
@@ -300,9 +307,8 @@
                  zv2(i,l)=zv2(i,l)+zalpha*(zvm-zv2(i,l))
                  do iq=1,nq
-c                  zq2(i,l,iq)=zq2(i,l,iq)+zalpha*(zqm(iq)-zq2(i,l,iq)) 
+!                  zq2(i,l,iq)=zq2(i,l,iq)+zalpha*(zqm(iq)-zq2(i,l,iq)) 
                    zq2(i,l,iq)=zqm(iq)
                  end do
               ENDDO
-c              diag_alpha(i)=zalpha  !temporaire
               if (ico2.ne.0) then
                 DO l=l1, l2
@@ -311,13 +317,77 @@
               end if
 
- 
+
               l2 = l2 + 1
-c
-            END IF   ! fin traitement instabilité entre l1 et l2. 
-c                      On repart pour test à partir du l2 au dessus...
-          ENDDO   ! End Loop sur l2 vers le haut 
-c
-      ENDDO
-c
+
+            END IF   ! End of l1 to l2 instability treatment
+                     ! We now continue to test from l2 upwards
+
+          ENDDO   ! End of upwards loop on l2
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!     check conservation
+         cadjncons=0.0
+         if(water)then
+         do l = 1, nlay
+            masse = (pplev(i,l) - pplev(i,l+1))/g
+            iq    = igcm_h2o_vap
+            cadjncons = cadjncons + 
+     &           masse*(zq2(i,l,iq)-zq(i,l,iq))/ptimestep 
+         end do
+         endif
+
+         if(cadjncons.lt.-1.e-6)then
+            print*,'convadj has just crashed...'
+            print*,'i  = ',i
+            print*,'l1 = ',l1
+            print*,'l2 = ',l2
+            print*,'cadjncons        = ',cadjncons
+         do l = 1, nlay
+            print*,'dsig         = ',dsig(l)
+         end do         
+         do l = 1, nlay
+            print*,'dsig         = ',dsig(l)
+         end do
+         do l = 1, nlay
+            print*,'sig         = ',sig(l)
+         end do
+         do l = 1, nlay
+            print*,'pplay(ig,:)         = ',pplay(i,l)
+         end do
+         do l = 1, nlay+1
+            print*,'pplev(ig,:)         = ',pplev(i,l)
+         end do
+         do l = 1, nlay
+            print*,'ph(ig,:)         = ',ph(i,l)
+         end do
+         do l = 1, nlay
+            print*,'ph(ig,:)         = ',ph(i,l)
+         end do
+         do l = 1, nlay
+            print*,'ph(ig,:)         = ',ph(i,l)
+         end do
+         do l = 1, nlay
+            print*,'zh(ig,:)         = ',zh(i,l)
+         end do
+         do l = 1, nlay
+            print*,'zh2(ig,:)        = ',zh2(i,l)
+         end do
+         do l = 1, nlay
+            print*,'zq(ig,:,vap)     = ',zq(i,l,igcm_h2o_vap)
+         end do
+         do l = 1, nlay
+            print*,'zq2(ig,:,vap)    = ',zq2(i,l,igcm_h2o_vap)
+         end do
+            print*,'zqm(vap)         = ',zqm(igcm_h2o_vap)
+            print*,'jadrs=',jadrs
+
+            call abort
+         endif
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+
+      ENDDO
+
       DO l=1,nlay
         DO ig=1,ngrid
@@ -338,5 +408,6 @@
       end if
 
-c     output
+
+!     output
 !      if (ngrid.eq.1) then
 !         ig=1
@@ -349,4 +420,4 @@
 
 
-      RETURN
-      END
+      return
+      end
Index: /trunk/LMDZ.GENERIC/libf/phystd/cpdet.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/cpdet.F	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/cpdet.F	(revision 253)
@@ -0,0 +1,123 @@
+! ADAPTATION GCM POUR CP(T)
+c======================================================================
+c S. Lebonnois, 10/2007:
+c
+c VENUS: Cp(T) = cpp*(T/T0)^nu 
+c avec T0=460. et nu=0.35
+c cpp=RCPD=cp0 = 1000.
+c R/RCPD = RKAPPA
+c
+c La fonction d'Exner reste pk = RCPD*(play/pref)**RKAPPA
+c 
+c T et teta (temperature potentielle) sont liees par:
+c 
+c   integrale[teta a T](cp/T dT) = integrale[pref a p](R/p dp)
+c
+c Dans le cas de l'expression pour Venus, ca donne:
+c
+c   teta**nu = T**nu - nu * T0**nu * ln[ (p/pref)**RKAPPA ]
+c ou
+c   teta**nu = T**nu - nu * T0**nu * ln[pk/RCPD]
+c
+c On passe de T a teta par t2tpot(t,teta,pk)
+c On passe de teta a T par tpot2t(teta,t,pk)
+c
+c Pour DT <-> Dteta, on utilise: dteta = dT *(T/teta)**(nu-1)
+c -> routine dt2dtpot(dt,dteta,t,teta) 
+c (utilisee seulement pour le contregradient)
+c
+c======================================================================
+
+      FUNCTION cpdet(t)
+      IMPLICIT none
+#include "cpdet.h"
+
+      real cpdet,t
+
+      cpdet = cp0*(t/t0)**nu
+
+      return
+      end
+      
+c======================================================================
+c======================================================================
+
+      SUBROUTINE t2tpot(npoints,yt, yteta, ypk)
+      IMPLICIT none
+c======================================================================
+c Arguments:
+c
+c yt   --------input-R- Temperature
+c yteta-------output-R- Temperature potentielle
+c ypk  --------input-R- Fonction d'Exner: RCPD*(pplay/pref)**RKAPPA
+c
+c======================================================================
+#include "cpdet.h"
+
+      integer npoints
+      REAL    yt(npoints), yteta(npoints), ypk(npoints)
+      
+      yteta = yt**nu - nu * t0**nu * log(ypk/cp0)
+      yteta = yteta**(1./nu)
+        
+
+      !yteta = yt/ypk
+
+
+      return
+      end
+
+c======================================================================
+c======================================================================
+
+      SUBROUTINE tpot2t(npoints,yteta, yt, ypk)
+      IMPLICIT none
+c======================================================================
+c Arguments:
+c
+c yteta--------input-R- Temperature potentielle
+c yt   -------output-R- Temperature
+c ypk  --------input-R- Fonction d'Exner: RCPD*(pplay/pref)**RKAPPA
+c
+c======================================================================
+#include "cpdet.h"
+
+      integer npoints
+      REAL yt(npoints), yteta(npoints), ypk(npoints)
+
+      yt = yteta**nu + nu * t0**nu * log(ypk/cp0)
+      yt = yt**(1./nu)
+
+      !yt = yteta*ypk
+
+      return
+      end
+
+c$$$c======================================================================
+c$$$c======================================================================
+c$$$
+c$$$      SUBROUTINE dt2dtpot(npoints,ydt, ydteta, yt, yteta, ypk, ydpk)
+c$$$      IMPLICIT none
+c$$$c======================================================================
+c$$$c Arguments:
+c$$$c
+c$$$c ydt  --------input-R- D Temperature
+c$$$c ydteta------output-R- D Temperature potentielle
+c$$$c yt   --------input-R- Temperature
+c$$$c yteta--------input-R- Temperature potentielle
+c$$$c ypk  --------input-R- Fonction d'Exner: RCPD*(pplay/pref)**RKAPPA
+c$$$c ydpk  -------input-R- D Fonction d'Exner
+c$$$c
+c$$$c======================================================================
+c$$$#include "cpdet.h"
+c$$$
+c$$$      integer npoints
+c$$$      REAL    ydt(npoints), ydteta(npoints), ydpk(npoints)
+c$$$      REAL    yt(npoints), yteta(npoints), ypk(npoints)
+c$$$      
+c$$$      ydteta =  yteta**(1.-nu)* (ydt * yt**(nu-1.) 
+c$$$     .                           - t0**nu * ydpk / ypk)
+c$$$        
+c$$$      return
+c$$$      end
+
Index: /trunk/LMDZ.GENERIC/libf/phystd/cpdet.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/cpdet.h	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/cpdet.h	(revision 253)
@@ -0,0 +1,12 @@
+!-----------------------------------------------------------------------
+! INCLUDE cpdet.h
+
+      real cp0,t0,nu
+!      parameter (cp0 = 1000.) !doit etre egal a cpp (dyn) et RCPD (phy)
+      parameter (cp0 = 800.) !doit etre egal a cpp (dyn) et RCPD (phy)
+!      parameter (t0  = 460.)
+      parameter (t0  = 480.)
+!      parameter (t0  = 300.)
+      parameter (nu  = 0.35)
+!      parameter (nu  = 1.0)
+!-----------------------------------------------------------------------
Index: /trunk/LMDZ.GENERIC/libf/phystd/datafile.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/datafile.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/datafile.h	(revision 253)
@@ -4,6 +4,7 @@
 !  Address of the directory containing tables of data needed by the UCM
 
-      character (len=100) :: datafile
-!      data datafile /'/san/home/rdword/gcm/datagcm'/  ! gnome iDataPlex
-      data datafile /'/u/rwlmd/datagcm'/  ! planetary cluster
+      character (len=300) :: datafile
+!      data datafile /'/home/rdword/gcm/datagcm_lite'/  ! laptop
+      data datafile /'/san/home/rdword/gcm/datagcm'/  ! gnome iDataPlex
+!      data datafile /'/u/rwlmd/datagcm'/  ! planetary cluster
 !-----------------------------------------------------------------------
Index: /trunk/LMDZ.GENERIC/libf/phystd/dimphys.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/dimphys.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/dimphys.h	(revision 253)
@@ -8,4 +8,5 @@
       integer, parameter :: nlayermx = llm 
 ! nsoilmx : number of subterranean layers
-       integer, parameter :: nsoilmx = 18 
+      !integer, parameter :: nsoilmx = 4 ! for a test 
+      integer, parameter :: nsoilmx = 18 ! for z1=0.02 cm, depth = 104.8 m 
 !-----------------------------------------------------------------------
Index: /trunk/LMDZ.GENERIC/libf/phystd/evap.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/evap.F	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/evap.F	(revision 253)
@@ -0,0 +1,78 @@
+      subroutine evap(dtime,pt, pq, pdq, pdt,  
+     $     dqevap,dtevap, qevap, tevap) 
+        
+      use watercommon_h 
+
+      implicit none
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "tracer.h"
+#include "comcstfi.h"
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Evaporation of all water in the atmopshere.
+!     
+!     Authors
+!     -------
+!     Adapted from the LMDTERRE code by B. Charnay (2010)
+!     Original author Z. X. Li (1993)
+!     
+!==================================================================
+
+! Arguments:
+      REAL pt(ngridmx,nlayermx) 
+      REAL pq(ngridmx,nlayermx,nqmx) 
+      REAL pdt(ngridmx,nlayermx) 
+      REAL pdq(ngridmx,nlayermx,nqmx) 
+      REAL dqevap(ngridmx,nlayermx)
+      REAL dtevap(ngridmx,nlayermx)
+      REAL qevap(ngridmx,nlayermx,nqmx)
+      REAL dtime
+ 
+! Local:
+      REAL tevap(ngridmx,nlayermx) 
+      REAL zlvdcp
+      REAL zlsdcp
+      REAL zdelta
+      INTEGER l,ig
+
+!
+! Re-evaporer l'eau liquide nuageuse
+!
+
+      DO l=1,nlayermx
+        DO ig=1,ngridmx
+         qevap(ig,l,igcm_h2o_vap)=pq(ig,l,igcm_h2o_vap)	
+     s          	          +pdq(ig,l,igcm_h2o_vap)*dtime
+         qevap(ig,l,igcm_h2o_ice)=pq(ig,l,igcm_h2o_ice)	
+     s                            +pdq(ig,l,igcm_h2o_ice)*dtime
+         tevap(ig,l)=pt(ig,l)+pdt(ig,l)*dtime
+	ENDDO
+      ENDDO
+
+      DO l = 1, nlayermx  
+      	DO ig = 1, ngridmx
+         zlvdcp=RLVTT/RCPD!/(1.0+RVTMP2*qevap(ig,l,igcm_h2o_vap))
+         zlsdcp=RLSTT/RCPD!/(1.0+RVTMP2*qevap(ig,l,igcm_h2o_vap))
+         ! ignoring qevap term creates huge difference when qevap large!!!
+
+         zdelta = MAX(0.,SIGN(1.,To-tevap(ig,l))) ! what is this?
+                                                  ! for division between water / liquid
+	 dqevap(ig,l) = MAX(0.0,qevap(ig,l,igcm_h2o_ice))/dtime
+         dtevap(ig,l) = - dqevap(ig,l)*RLVTT/RCPD ! exactly as in largescale.F
+!         dtevap(ig,l) = - dqevap(ig,l)	
+!     s                       * (zlvdcp*(1.-zdelta)+zlsdcp*zdelta)
+         qevap(ig,l,igcm_h2o_vap) = qevap(ig,l,igcm_h2o_vap)	
+     s     	                    +dqevap(ig,l)*dtime
+	 qevap(ig,l,igcm_h2o_ice) = 0.0
+         tevap(ig,l) = tevap(ig,l)+dtevap(ig,l)*dtime
+
+      	ENDDO
+      ENDDO
+
+      RETURN
+      END
Index: /trunk/LMDZ.GENERIC/libf/phystd/fisice.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/fisice.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/fisice.h	(revision 253)
@@ -1,4 +1,4 @@
-c-----------------------------------------------------------------------
-c INCLUDE fisice.h
+!-----------------------------------------------------------------------
+! INCLUDE fisice.h
 
       COMMON/fisice/dqsf,rice,nuice,rdust,zcondicea
@@ -10,5 +10,5 @@
                                    !   MODIF_JBM_08W45
       REAL rdust(ngridmx,nlayermx) ! Prescribed dust radius in each layer (m) 
-c Variables used to define water ice scavenging by atmos. CO2 condensing
+! Variables used to define water ice scavenging by atmos. CO2 condensing
       REAL zcondicea(ngridmx,nlayermx)
-c-----------------------------------------------------------------------
+!-----------------------------------------------------------------------
Index: /trunk/LMDZ.GENERIC/libf/phystd/forceWCfn.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/forceWCfn.F	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/forceWCfn.F	(revision 253)
@@ -0,0 +1,47 @@
+      subroutine forceWCfn(pplev,pt,dq,dqs)
+
+      implicit none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Force tracer conservation in a column for a given pair of 
+!     delta q, delta q_s
+!
+!     Authors
+!     ------- 
+!     R. Wordsworth
+!     
+!==================================================================
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+#include "tracer.h"
+
+      real masse, Wtot, Wdiff
+
+      real pplev(ngridmx,nlayermx+1)
+      real pt(ngridmx)
+
+      real dqs(ngridmx,nqmx) 
+      real dq(ngridmx,nlayermx,nqmx)
+
+      integer iq, ig, ilay
+
+      do iq=1,nqmx 
+        do ig=1,ngridmx
+           Wtot = 0.0
+           do ilay=1,nlayermx
+              masse = (pplev(ig,ilay) - pplev(ig,ilay+1))/g
+              Wtot  = Wtot + masse*dq(ig,ilay,iq)
+           enddo
+           Wdiff = Wtot + dqs(ig,iq)
+         
+           dqs(ig,iq) = dqs(ig,iq) - Wdiff
+        enddo
+      enddo
+
+      end 
+
Index: /trunk/LMDZ.GENERIC/libf/phystd/gases.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/gases.h	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/gases.h	(revision 253)
@@ -0,0 +1,12 @@
+!-----------------------------------------------------------------------
+! INCLUDE 'gases.h'
+
+      integer, parameter :: ngasmx = 2 
+      integer vgas
+      character*3 :: gnom(ngasmx) ! name of the gas
+!      character(len=3) :: gnom(ngasmx) ! name of the gas
+      real gfrac(ngasmx)
+
+      COMMON/gases/gnom,gfrac,vgas 
+
+!-----------------------------------------------------------------------
Index: /trunk/LMDZ.GENERIC/libf/phystd/gfluxi.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/gfluxi.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/gfluxi.F	(revision 253)
@@ -70,6 +70,8 @@
         LAMDA(L) = ALPHA(L)*(1.0-W0(L)*COSBAR(L))/UBARI
 
-        NT2   = TLEV(2*L+2)*10.0D0-499
-        NT    = TLEV(2*L)*10.0D0-499
+        !NT2   = TLEV(2*L+2)*10.0D0-499
+        !NT    = TLEV(2*L)*10.0D0-499
+        NT    = int(TLEV(2*L)*10.0D0)   - NTstar+1
+        NT2   = int(TLEV(2*L+2)*10.0D0) - NTstar+1
 
         B1(L) = (PLANCKIR(NW,NT2)-PLANCKIR(NW,NT))/DTAU(L)
@@ -83,6 +85,8 @@
       LAMDA(L) = ALPHA(L)*(1.0-W0(L)*COSBAR(L))/UBARI
 
-      NT    = TLEV(2*L+1)*10.0D0-499
-      NT2   = TLEV(2*L)*10.0D0-499
+      !NT    = TLEV(2*L+1)*10.0D0-499
+      !NT2   = TLEV(2*L)*10.0D0-499
+      NT    = int(TLEV(2*L+1)*10.0D0) - NTstar+1
+      NT2   = int(TLEV(2*L)*10.0D0)   - NTstar+1
       B1(L) = (PLANCKIR(NW,NT)-PLANCKIR(NW,NT2))/DTAU(L)
       B0(L) = PLANCKIR(NW,NT2)
Index: /trunk/LMDZ.GENERIC/libf/phystd/gfluxv.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/gfluxv.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/gfluxv.F	(revision 253)
@@ -66,4 +66,5 @@
 
 
+
       NAYER  = L_NLAYRAD
       TAUMAX = L_TAUMAX    !Default is 35.0
@@ -84,4 +85,5 @@
         W0(L)       = WDEL(L)*(1.0D0-CDEL(L)**2)/FACTOR
         COSBAR(L)   = CDEL(L)/(1.0D0+CDEL(L))
+
         DTAU(L)     = DTDEL(L)*FACTOR
         TAU(L+1)    = TAU(L)+DTAU(L)
@@ -90,5 +92,4 @@
         TAUCUM(K+1) = TAUCUM(K) + (TAUCUMIN(K+1)-TAUCUMIN(K))*FACTOR
       END DO
-
 
 !  Bottom layer
@@ -102,5 +103,4 @@
       TAUCUM(2*L+1) = TAU(L+1)
 
-
       BSURF = RSF*UBAR0*F0PI*EXP(-MIN(TAU(L+1),TAUMAX)/UBAR0)
       ! new definition of BSURF
@@ -109,21 +109,34 @@
       ! of the radiation scattered in the forward direction
 
-
 C     WE GO WITH THE QUADRATURE APPROACH HERE.  THE "SQRT(3)" factors
 C     ARE THE UBARV TERM.
 
       DO L=1,L_NLAYRAD
-        
-        ALPHA(L)=SQRT( (1.0-W0(L))/(1.0-W0(L)*COSBAR(L)) )
-
+
+        ALPHA(L)=SQRT( (1.0-W0(L))/(1.0-W0(L)*COSBAR(L) ) )
 
 C       SET OF CONSTANTS DETERMINED BY DOM 
 
+!     Quadrature method
         G1(L)    = (SQRT(3.0)*0.5)*(2.0- W0(L)*(1.0+COSBAR(L)))
         G2(L)    = (SQRT(3.0)*W0(L)*0.5)*(1.0-COSBAR(L))
         G3(L)    = 0.5*(1.0-SQRT(3.0)*COSBAR(L)*UBAR0)
 
-
-c     this is Quadrature
+!     ----- some other methods... (RDW) ------
+
+!     Eddington method
+!        G1(L)    =  0.25*(7.0 - W0(L)*(4.0 - 3.0*COSBAR(L)))
+!        G2(L)    = -0.25*(1.0 - W0(L)*(4.0 - 3.0*COSBAR(L)))
+!        G3(L)    =  0.25*(2.0 - 3.0*COSBAR(L)*UBAR0)
+
+!     delta-Eddington method
+!        G1(L)    =  (7.0 - 3.0*g^2 - W0(L)*(4.0 + 3.0*g) + W0(L)*g^2*(4*beta0 + 3*g)) / &
+!                             (4* (1 - g^2*()   ))  0.25*(7.0 - W0(L)*(4.0 - 3.0*COSBAR(L)))
+
+!     Hybrid modified Eddington-delta function method
+
+!     ----------------------------------------
+
+c     So they use Quadrature
 c     but the scaling is Eddington?
 
@@ -255,5 +268,5 @@
 
       fluxdn = fluxdn+UBAR0*F0PI*EXP(-MIN(TAUCUM(1),TAUMAX)/UBAR0)
- 
+
 C     This is for the "special" bottom layer, where we take
 C     DTAU instead of DTAU/2.
@@ -269,5 +282,4 @@
 
 
-
 C     THERE IS A POTENTIAL PROBLEM HERE IF W0=0 AND UBARV=UBAR0
 C     THEN DENOM WILL VANISH. THIS ONLY HAPPENS PHYSICALLY WHEN 
@@ -304,8 +316,4 @@
 
 
-
-
       RETURN
-
-
       END
